Package org.eclipse.cdt.core.dom.ast

# Interface IASTAttributeOwner

All Superinterfaces:
  `IASTNode`

All Known Subinterfaces:
  `IASTArrayDeclarator`, `IASTArrayModifier`, `IASTBreakStatement`, `IASTCaseStatement`, `IASTCompositeTypeSpecifier`, `IASTCompoundStatement`, `IASTContinueStatement`, `IASTDeclarationStatement`, `IASTDeclarator`, `IASTDeclSpecifier`, `IASTDefaultStatement`, `IASTDoStatement`, `IASTElaboratedTypeSpecifier`, `IASTEnumerationSpecifier`, `IASTEnumerationSpecifier.IASTEnumerator`, `IASTExpressionStatement`, `IASTFieldDeclarator`, `IASTForStatement`, `IASTFunctionDeclarator`, `IASTGotoStatement`, `IASTIfStatement`, `IASTLabelStatement`, `IASTNamedTypeSpecifier`, `IASTNullStatement`, `IASTPointer`, `IASTPointerOperator`, `IASTProblemStatement`, `IASTReturnStatement`, `IASTSimpleDeclaration`, `IASTSimpleDeclSpecifier`, `IASTStandardFunctionDeclarator`, `IASTStatement`, `IASTSwitchStatement`, `IASTWhileStatement`, `ICASTArrayModifier`, `ICASTCompositeTypeSpecifier`, `ICASTDeclSpecifier`, `ICASTElaboratedTypeSpecifier`, `ICASTEnumerationSpecifier`, `ICASTKnRFunctionDeclarator`, `ICASTPointer`, `ICASTSimpleDeclSpecifier`, `ICASTTypedefNameSpecifier`, `ICPPASTAliasDeclaration`, `ICPPASTArrayDeclarator`, `ICPPASTCatchHandler`, `ICPPASTCompositeTypeSpecifier`, `ICPPASTCompoundStatement`, `ICPPASTDeclarator`, `ICPPASTDeclSpecifier`, `ICPPASTDeductionGuide`, `ICPPASTElaboratedTypeSpecifier`, `ICPPASTEnumerationSpecifier`, `ICPPASTFieldDeclarator`, `ICPPASTForStatement`, `ICPPASTFunctionDeclarator`, `ICPPASTFunctionDefinition`, `ICPPASTFunctionTryBlockDeclarator`, `ICPPASTFunctionWithTryBlock`, `ICPPASTIfStatement`, `ICPPASTNamedTypeSpecifier`, `ICPPASTNamespaceDefinition`, `ICPPASTParameterDeclaration`, `ICPPASTPointerToMember`, `ICPPASTRangeBasedForStatement`, `ICPPASTReferenceOperator`, `ICPPASTSimpleDeclSpecifier`, `ICPPASTStructuredBindingDeclaration`, `ICPPASTSwitchStatement`, `ICPPASTTryBlockStatement`, `ICPPASTTypeTransformationSpecifier`, `ICPPASTUsingDeclaration`, `ICPPASTUsingDirective`, `ICPPASTWhileStatement`, `IGCCASTSimpleDeclSpecifier`, `IGNUASTGotoStatement`, `IGPPASTDeclSpecifier`, `IGPPASTPointer`, `IGPPASTPointerToMember`, `IGPPASTSimpleDeclSpecifier`

public interface IASTAttributeOwner extends IASTNode
An AST node that may have attributes.

Since:
  5.4
Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`IASTNode.CopyStyle`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final ASTNodeProperty`
`ATTRIBUTE`
Deprecated.
Not used.
`static final ASTNodeProperty`
`ATTRIBUTE_SPECIFIER`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`EMPTY_NODE_ARRAY`

## Method Summary

Modifier and Type
Method
Description
`void`
`addAttribute(IASTAttribute attribute)`
Deprecated.
Ignored.
`void`
`addAttributeSpecifier(IASTAttributeSpecifier attributeSpecifier)`
Adds an attribute specifier to the node.
`IASTAttribute[]`
`getAttributes()`
Returns the array of all attributes.
`IASTAttributeSpecifier[]`
`getAttributeSpecifiers()`
Returns an array of all the node's attribute specifiers.

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`accept, contains, copy, copy, getChildren, getContainingFilename, getFileLocation, getLeadingSyntax, getNodeLocations, getOriginalNode, getParent, getPropertyInParent, getRawSignature, getSyntax, getTrailingSyntax, getTranslationUnit, isActive, isFrozen, isPartOfTranslationUnitFile, setParent, setPropertyInParent`

## Field Details

### ATTRIBUTE_SPECIFIER

static final ASTNodeProperty ATTRIBUTE_SPECIFIER

Since:
  5.7

### ATTRIBUTE

@Deprecated static final ASTNodeProperty ATTRIBUTE
Deprecated.
Not used.

Restriction:
  This field is not intended to be referenced by clients.

## Method Details

### getAttributeSpecifiers

IASTAttributeSpecifier[] getAttributeSpecifiers()
Returns an array of all the node's attribute specifiers.

Since:
  5.7

### addAttributeSpecifier

void addAttributeSpecifier(IASTAttributeSpecifier attributeSpecifier)
Adds an attribute specifier to the node.

Since:
  5.7

### getAttributes

IASTAttribute[] getAttributes()
Returns the array of all attributes.

### addAttribute

@Deprecated void addAttribute(IASTAttribute attribute)
Deprecated.
Ignored. Attributes should not be assigned to nodes directly, but have to be wrapped by attribute specifiers.

Restriction:
  This method is not intended to be referenced by clients.